<p>Pretpostavimo da su nam na raspolaganju VHDL-modeli sklopova <em>sklop1</em> i <em>sklop2</em>. Njihova
   sučelja grafički su prikazana na slikama 1 i 2.

<figure class="mlFigure">
<img src="@#file#(sklop1i.svg)" alt="Sučelje sklopa"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Sučelje sklopa <em>sklop1</em>.</figcaption>
</figure>

<figure class="mlFigure">
<img src="@#file#(sklop2i.svg)" alt="Sučelje sklopa"><br>
<figcaption><span class="mlFigKey">Slika 2.</span> Sučelje sklopa <em>sklop2</em>.</figcaption>
</figure>

<p>Pretpostavimo nadalje da su VHDL-specifikacije sučelja tih sklopova napisane kako slijedi u nastavku.</p>

<p>Sučelje sklopa <em>sklop1</em> definirano je na sljedeći način.</p>
<pre><code>ENTITY sklop1 IS PORT (
  a: IN std_logic;
  b: IN std_logic;
  c: IN std_logic;
  f: OUT std_logic
);
END sklop1;</code></pre>

<p>Sučelje sklopa <em>sklop2</em> definirano je na sljedeći način.</p>
<pre><code>ENTITY sklop2 IS PORT (
  a: IN std_logic;
  b: IN std_logic;
  f: OUT std_logic
);
END sklop2;</code></pre>

<p>Naš je zadatak modelirati komponentu <em>sklop3</em> čije je sučelje zadano na slici 3.</p>

<figure class="mlFigure">
<img src="@#file#(sklop3i.svg)" alt="Sučelje sklopa"><br>
<figcaption><span class="mlFigKey">Slika 3.</span> Sučelje sklopa <em>sklop3</em>.</figcaption>
</figure>

<p>Sučelje sklopa <em>sklop3</em> stoga ćemo u VHDL-u opisati na sljedeći način.</p>
<pre><code>ENTITY sklop3 IS PORT (
  a: IN std_logic;
  x: IN std_logic;
  y: IN std_logic;
  f: OUT std_logic;
  g: OUT std_logic
);
END sklop3;</code></pre>

<p>Neka sklop <em>sklop3</em> ulaze <code>a</code>, <code>x</code> i <code>y</code> u izlaze <code>f</code>
   i <code>g</code> transformira uporabom komponenata <em>sklop1</em> i <em>sklop2</em>, prema slici 4.</p>

<figure class="mlFigure">
<img src="@#file#(sklop3.svg)" alt="Shema sklopa"><br>
<figcaption><span class="mlFigKey">Slika 4.</span> Shema sklopa <em>sklop3</em>.</figcaption>
</figure>

<p>Proanalizirajmo prikazanu shemu. Sklop <em>sklop3</em> koristi jedan primjerak sklopa <em>sklop1</em> 
   te jedan primjerak sklopa <em>sklop2</em>. 
</p>
<p>Ulaz <code>a</code> sklopa <em>sklop3</em> dovodi se
   na ulaz <code>a</code> sklopa <em>sklop1</em> te na ulaz <code>b</code> sklopa <em>sklop2</em>.
   Ulaz <code>x</code> sklopa <em>sklop3</em> vodi se na ulaz <code>b</code> sklopa <em>sklop1</em>.
   Ulaz <code>y</code> sklopa <em>sklop3</em> vodi se na ulaz <code>c</code> sklopa <em>sklop1</em>.
   Izlaz <code>f</code> sklopa <em>sklop1</em> vodi se na izlaz sklopa <em>sklop3</em> te ujedno i na
   ulaz <code>a</code> sklopa <em>sklop2</em>. Izlaz <code>f</code> sklopa <em>sklop2</em> vodi se
   na izlaz <code>g</code> sklopa <em>sklop3</em>.
</p>

<p><strong>Dorada sheme sklopa</strong></p>

<p>Prije no što krenemo pisati strukturni model, shemu prikazanu na slici 4 moramo doraditi dodavanjem
   nekoliko bilješki. Prvo što moramo učiniti jest <em>svakom prikazanom sklopu dati njegovo jedinstveno
   ime</em>.
</p>
<p>Zamislite da su na shemi dva primjerka sklopa <em>sklop1</em> umjesto jednog primjerka sklopa 
   <em>sklop1</em> i jednog primjerka sklopa <em>sklop2</em> (drugim riječima, zamislite da je i onaj
   sklop dolje desno također primjerak sklopa <em>sklop1</em>). U tom slučaju ne bismo mogli napisati
   da se izlaz <code>f</code> sklopa <em>sklop1</em> vodi na izlaz <code>f</code> našeg modeliranog
   sklopa <em>sklop3</em> - naime, da, to bi vrijedilo za gornji <em>sklop1</em> ali ne bi za donji
   <em>sklop1</em>. Kako bi se osiguralo da ne može doći do nedoumice o kojem sklopu točno govorimo,
   VHDL zahtijeva da svakom primjerku sklopa damo njegovo jedinstveno ime. Na shemama ćemo vrstu sklopa
   pisati iznad simbola sklopa (i to je već napravljeno na slici 4), a ime sklopa ispod simbola sklopa
   (to moramo dodati). Ovako obilježena shema prikazana je na slici 5.</p>

<figure class="mlFigure">
<img src="@#file#(sklop3b.svg)" alt="Shema sklopa"><br>
<figcaption><span class="mlFigKey">Slika 5.</span> Dopunjena shema sklopa <em>sklop3</em>.</figcaption>
</figure>

<p>Primijetite, uveli smo dva imena: imenom <code>c1</code> obilježili smo gornji lijevi primjerak sklopa
   <em>sklop1</em>, a imenom <code>c2</code> obilježili smo donji desni primjerak sklopa <em>sklop2</em>.
   Na ovoj shemi do zabune ne može doći jer su oba primjerka primjerci različitih sklopova; no da su oba
   primjerci istog sklopa, tada bismo jedino pozivanjem na dodijeljeno ime mogli razlikovati pojedine sklopove.
</p>

<p>Prilikom strukturnog modeliranja, morat ćemo reći kako su ulazi i izlazi korištenih komponenata spojeni
   s ulazima i izlazima modeliranog sklopa. Kod prikazane sheme to neće biti moguće napraviti izravno. Naime,
   izlaz <code>f</code> komponente <code>c1</code> spojen je na izlaz <code>f</code> modeliranog sklopa ali je
   istovremeno spojen i na ulaz <code>a</code> komponente <code>c2</code>. Ako se izlaz bilo koje komponente
   razvodi do ulaza neke druge komponente, za to moramo koristiti pomoćne interne signale. Stoga ćemo na shemu
   sklopa dodati zabilješku da je žica koja spaja izlaz <code>f</code> komponente <code>c1</code> s izlazom 
   <code>f</code> modeliranog sklopa i ulazom <code>a</code> komponente <code>c2</code> zapravo pomoćni
   interni signal koji ćemo nazvati <code>s</code> (potpuno proizvoljno odabrano ime). Ovako pripremljena
   shema prikazana je na slici 6.
</p>

<figure class="mlFigure">
<img src="@#file#(sklop3c.svg)" alt="Shema sklopa"><br>
<figcaption><span class="mlFigKey">Slika 6.</span> Konačna dopunjena shema sklopa <em>sklop3</em>.</figcaption>
</figure>

<p>Zapamtite sljedeći naputak i uvijek ga se pridržavajte pri pisanju strukturnih modela.
</p>

<div class="mlImportant">
<p>Pri strukturnom modeliranju, prvi korak jest pripremiti obilježenu shemu sklopa. Na toj shemi jasno moraju
   biti naznačene:</p>
<ul>
<li>vrste korištenih komponenata (pišemo ih iznad simbola sklopa),</li>
<li>jedinstvena imena komponenata (pišemo ih ispod simbola sklopa) te</li>
<li>nazivi internih signala koje ćemo koristiti pri povezivanju komponenata.</li>
</ul>
</div>


